Page MenuHomePhabricator

Community Bonding Report for Automated Testing and Integration of IFTTT support to Wikidata
Closed, ResolvedPublic

Description

Community bonding

Week 1 (23nd April - 29th April)

  • Created Project progress report page (this page) as a sub-page of my profile page to keep track of my work during the Summer of Code and a brief log of this report in blog spot here: project progress blogspot.
  • Created a phabricator conference to enable a synchronized discussion about the project progress with my mentors and notify them with recent updates on the project's progress and any other updates.
  • Held meetings with some of my mentors individually, having their weekly schedules for code review, guidance etc... This enabled me to get their available times, taking into consideration time zones.
  • Extending Wikipedia IFTTT to support RSS feeds. Worked on the Article revisions and User revision feeds in addition to the Article of the Day, Word of the Day and New article feeds I already worked on. Commit on github is here: Commit and the pull request for the work here: PR3.
  • Created a Wikimedia Tool Labs account and submitted to the mentor (Stephen) so that he could integrate me to the dev edition of the Wikipedia IFTTT application on Tool labs. This will enable me to be running Database Access Layer (DAL) tests that is concerned with database driven feeds.
  • Requested for access to be added to a group on tools lab so that my account can be given rights under a particular project. In this case, testing on Wikipedia IFTTT and development of Wikidata IFTTT during developing the project.
  • Tool Lab account request was processed and approved by Tim Landscheidt and at this point, it is just left for me to have access to the IFTTT dev project on tools lab for testing.
  • Stephen (mentor) added me to Tool Labs on the IFTTT-Dev project so that I can perform testing of the RSS feeds work that I have done. I successfully logged into Tool Labs after adding my SSH key to my tool labs profile. Ran DAL (Database Access Layer) tests for feeds that needed DAL for its functioning and all where successful.

Week 2 (30th April - 7th May)

  • Created a discussion thread here, where my mentors will suggest and decide on the triggers that will be implemented for Wikidata IFTTT web app. Also, I am personally doing some thinking and research on the triggers which will be implemented and will suggest to mentors and if approved, all the decided triggers will be implemented during the coding period.
  • Further my leaning and investigation on Wikidata API, installed a local instance of the API on my computer and started running local queries on my_wiki database. At this point, I am understanding how the Wikidata API work and following the API's documentation at Wikidata API Docs.
  • Sent a formal introductory mail to the Wikimedia dev mailing list, Wikidata and Wikidata dev mailing list informing the community members about my acceptance to the GSoC program and also the project I am working on. The links to the mail in the lists are here: Wikimedia-Dev-List, Wikidata-List and Wikidata-Dev-List
  • Reading documentations about IFTTT concept and also studying in detail Stephen's implementation of IFTTT web app for Wikipedia. Reading docs on RESTful API's and JSON/XML data transfer mechanisms.
  • Schedule a meeting and sent and email to my mentors including my academic supervisor on my GSoC project and the meeting agenda can be seen here: Meeting Agenda, meeting shall take place on Google Hangout and will be 1hr 30mins maximum.
  • Setup a hangout on air call and created an event on my YouTube channel where the call can be streamed live by other audience. Here is the link to the video/audio on YouTube: Live Video/Audio.
  • The meeting held and was very exciting. In this meeting, we had the following points cleared out:
    • Modification of time-line to suite the current demands for the project. Once I modify the time-line, I will put a link to it.
    • Agreed that we shall investigates all the following listed triggers for Wikidata and rank them to choose the best that will be implemented.
    • I shall no longer use Gerrit for development, so I shall use Github and as a result, I shall set-up Travis CI automated testing bot to help me with some testing aspects of the project.
    • We also agreed I will also spend some time writing test cases/suite for the current Wikipedia IFTTT web app and also write Wikidata's tests along side building the triggers. In addition to this, I shall also help write documentation for both the current app and the Wikidata app I shall develop.
  • Modified my GSoC proposal as agreed in the meeting with the mentors. This modification was done both on the Google docs version of the proposal and on the phabricator (T129016) version of the proposal.

Week 3 (8th May - 15th May)

  • Researched on how to set up Travis-CI bot with Github repositories and also specific to repositories with python projects (any version of python). Read on how to transfer Travis-CI bot setting from one repository to another.
  • Learned how to use Query module in the Wikidata API, using it in my local instance to run queries again the database. This enabled me to understand how the query module works. Under the query module, I learnt how to use;
    • list
    • meta
    • generator
    • prop
  • Researched on Unit testing and Integration testing in Python and most especially related to the IFTTT project. Unit testing will be based on the 8 triggers for Wikipedia IFTTT and the triggers I will develop for Wikidata. Also, in addition to the Unit tests, I shall also write integration tests for all the triggers in concern.
  • Practicing how to write unit tests in python using the "unittest" package and also reading how to run unit tests in python using "Nose". This will enable me to write unit tests for the IFTTT project.
  • Pushed a mini project on Github where I am using to practice my unit testing skills in python. The link to the repository can be found here: Math Functions & Unit Tests
  • Had in total of 3 meetings with the mentor with each greater than 1 hours to discuss on how to go about writing the tests. Which properties of the triggers to be tested and other parameters to be tested in the triggers. At the end, we had put in place all the parameters to be tested in triggers.
  • Researched about how to dynamically generate test cases in python since this will be needed in the project to automatically generate test cases for all the triggers rather than writing a test for each trigger in concern.
  • Investing the Wikidata list of proposed triggers and ranking them in order for I and the mentors to select the highest priority triggers to implement during the coding period. There are 6 triggers so far and they are going through a ranking process.

Week 4 (16th May - 22nd May)

  • Finalizing the ranking process of the Wikidata triggers with the mentors.
  • Wrapping up with the study of the code base and citing some key important core parts of the code that will be related to my GSoC project.
  • Reading flask docs on client side testing since this will be highly necessary for my project. This will enable me to test the app just withing the application not involving the servers.
  • Preparing to select triggers that will be implemented based on the ranking done by I and the mentors, but at this point, some mentors have not ranked the triggers so once they are done, triggers will be selected.
  • More research on client/server side testing of python application. Used the Flask Docs here.
  • Published my Community bonding meeting (Hangout on Air call with my mentors) on social media and the links can be found below;
  • Wrapping up with Community bonding and finalizing all stuffs preparing to start coding tomorrow :)
  • Let the coding begin !!!!!

Event Timeline

D3r1ck01 created this task.May 9 2016, 6:25 AM
Restricted Application added a subscriber: Zppix. · View Herald TranscriptMay 9 2016, 6:25 AM
D3r1ck01 updated the task description. (Show Details)May 9 2016, 6:38 AM
D3r1ck01 updated the task description. (Show Details)May 9 2016, 6:52 AM
D3r1ck01 moved this task from incoming to monitoring on the Wikidata board.
D3r1ck01 renamed this task from Community Bonding Report for IFTTT Project to Community Bonding Report for Integration of IFTTT support to Wikidata.May 9 2016, 7:02 AM
D3r1ck01 updated the task description. (Show Details)May 10 2016, 2:00 PM
D3r1ck01 updated the task description. (Show Details)May 10 2016, 2:11 PM
D3r1ck01 updated the task description. (Show Details)May 10 2016, 2:17 PM
D3r1ck01 updated the task description. (Show Details)May 12 2016, 3:32 PM
D3r1ck01 updated the task description. (Show Details)May 15 2016, 10:45 AM
D3r1ck01 renamed this task from Community Bonding Report for Integration of IFTTT support to Wikidata to Community Bonding Report for Automated Testing and Integration of IFTTT support to Wikidata.May 15 2016, 10:48 AM
D3r1ck01 updated the task description. (Show Details)May 15 2016, 11:25 AM
D3r1ck01 updated the task description. (Show Details)May 15 2016, 6:06 PM
D3r1ck01 updated the task description. (Show Details)
D3r1ck01 updated the task description. (Show Details)May 19 2016, 12:50 PM
D3r1ck01 updated the task description. (Show Details)May 22 2016, 4:46 PM
Lydia_Pintscher closed this task as Resolved.May 25 2016, 10:06 PM

I am closing this as requested by org admins. Good work, @D3r1ck01!

I am closing this as requested by org admins. Good work, @D3r1ck01!

Thanks very much @Lydia_Pintscher. I am grateful.